URAL1826. Minefield 题解

原题:

http://acm.timus.ru/problem.aspx?space=1&num=1826




1826. Minefield
Time limit: 0.5 second
Memory limit: 64 MB
To
fulfill an assignment, a reconnaissance group of n people must cross the
enemy‘s minefield. Since the group has only one mine detector, the
following course of action is taken: two agents cross the field to the
enemy‘s side and then one agent brings the mine detector back to the
remaining group. This is repeated until only two agents remain. These two
agents then cross the field together.
Each person gets across the field
at their own speed. The speed of a pair is determined by the speed of its
slower member.
Find the minimal time the whole group needs to get over
the minefield.
Input
The first line contains the integer n (2 ≤ n ≤
100). The i-th of the following n lines specifies the time the i-th member
of the group needs to get over the minefield (the time is an integer from
1 to 600).
Output
Output the minimal total time the group needs to
cross the minefield.

2~100个人要过雷区,只有一个探雷器,一次最多只能2个人过去,所以过去的流程是:过去2个回来一个过去2个回来一个…直到只剩2个的时候一起过去。2个一起走的时候以速度慢的人的速度为准。样例我看了好久没看懂,样例是4个人,单独过去的时间分别为1,2,5,10,先是1和2过去,1回来,5和10过去,2回来,1和2过去,一共2+1+10+2+2=17。

大致有两种策略,一种是最小的那个带大的过去,再回来带第二大的过去,再回来;另一种是最小的两个过去,最小的回来,然后最大的两个过去,第二小的回来。

好像可以贪心,这两种策略结束时都是最小的两个还在这边,最大的两个都去了那边,状态是一样的,所以这里选最优的策略就好。

不过我做的时候没想通,用了动规,i从大到小,dp[i][0]记录把i送过去时第二小的还在自己这边所耗的总时间,dp[i][1]记录把i送过去时第二小的在对面,所用的总时间。这样记录了第二小的位置,比较方便讨论几种送法。

动规代码如下:

 1 #include<iostream>
2 #include <cstdio>
3 #include <cstring>
4 #include <cstdlib>
5 #include<vector>
6 #include<algorithm>
7 #include<cstring>
8 #define MAXN 111
9 #define RE freopen("in.txt","r",stdin);
10 #define inf 6666666
11 using namespace std;
12
13 int n;
14 int a[MAXN];
15 int dp[MAXN][2];
16
17 int farm();
18 void init();
19
20 int main()
21 {
22 //RE
23 while(scanf("%d",&n)!=EOF)
24 {
25 farm();
26 }
27 return 0;
28 }
29
30 int farm()
31 {
32 int i,ans;
33 for(i=0;i<n;i++)
34 {
35 scanf("%d",&a[i]);
36 }
37 sort(a,a+n);
38 memset(dp,-1,sizeof(dp));
39 for(i=0;i<=n+1;i++)
40 {
41 dp[i][0]=inf;
42 dp[i][1]=inf;
43 }
44 dp[n][0]=0;
45 dp[n][1]=a[1]+a[0];
46 for(i=n-1;i>1;i--)
47 {
48 dp[i][0]=dp[i+1][0]+a[i]+a[0];
49 if(i<n-1) dp[i][0]=min(dp[i][0],dp[i+2][1]+a[i+1]+a[1]);
50 dp[i][1]=dp[i+1][1]+a[i]+a[0];
51 dp[i][1]=min(dp[i][1],dp[i][0]+a[1]+a[0]);
52 }
53 ans=min(dp[2][0]+a[1],dp[3][1]+a[2]);
54 printf("%d\n",ans);
55 return 0;
56 }
57
58
59 void init()
60 {
61
62 }

贪心的我没写…应该比这个简单。

时间: 2024-10-10 13:10:16

URAL1826. Minefield 题解的相关文章

洛谷 P1079 Vigen&#232;re 密码 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=1079 题目描述 16 世纪法国外交家 Blaise de Vigenère 设计了一种多表密码加密算法――Vigenère 密 码.Vigenère 密码的加密解密算法简单易用,且破译难度比较高,曾在美国南北战争中为 南军所广泛使用. 在密码学中,我们称需要加密的信息为明文,用 M 表示:称加密后的信息为密文,用 C 表示:而密钥是一种

8.8联考题解

今天的T1让我怀疑我是不是在做奥赛题--这考的是什么知识点啊这个,会不会用绝对值函数? Evensgn 的债务 时间限制: 1 Sec  内存限制: 128 MB 题目描述 Evensgn 有一群好朋友,他们经常互相借钱.假如说有三个好朋友A,B,C.A 欠 B 20 元,B 欠 C 20 元,总债务规模为 20+20=40 元.Evensgn 是个追求简约的人,他觉得这样的债务太繁杂了.他认为,上面的债务可以完全等价为 A 欠C20 元,B 既不欠别人,别人也不欠他.这样总债务规模就压缩到了 

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

(leetcode题解)Pascal&#39;s Triangle

Pascal's Triangle  Given numRows, generate the first numRows of Pascal's triangle. For example, given numRows = 5,Return [ [1], [1,1], [1,2,1], [1,3,3,1], [1,4,6,4,1] ] 题意实现一个杨辉三角. 这道题只要注意了边界条件应该很好实现出来,C++实现如下 vector<vector<int>> generate(int

2017ZZUACM省赛选拔试题部分题解----谨以纪念我这卡线滚粗的美好经历

写在前面: 其实心里有些小小的不爽又有点小小的舒畅,为啥捏?不爽当然是因为没被选拔上啦,舒畅捏则是因为没被选拔上反而让自己警醒,学长也提点很多很多."沉下去,然后一战成名"学长如是对我说,我很开心.其实这完全算不算是题解,只是我个人的一些小想法而已.而且到现在还有一题不会...让自己长点记性吧. 题目 A :聪明的田鼠 Time Limit: 1 Sec Memory Limit: 128 MB Description 田鼠MIUMIU来到了一片农田,农田可以看成是一个M*N个方格的矩

LeetCode-001题解

此题目摘自LeetCode001 Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

leetcode题解: Next Permutation

最近还一直在刷leetcode,当然,更多时候只是将题解写在自己的电脑上,没有分享出来.偶尔想起来的时候,就写出来. public class Solution { public void nextPermutation(int[] nums) { if(nums==null||nums.length<=1) return; nextPermutationHelp( nums,0,nums.length-1); } public void nextPermutationHelp(int []nu

HDU 5014 Number Sequence(2014 ACM/ICPC Asia Regional Xi&#39;an Online) 题解

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5014 Number Sequence Problem Description There is a special number sequence which has n+1 integers. For each number in sequence, we have two rules: ● ai ∈ [0,n] ● ai ≠ aj( i ≠ j ) For sequence a and sequ

HDU 1045 Fire Net 二分图Bipartite题解

本题可以使用DFS直接爆搜出答案,不过这样类型的题目其实是个二分图的题解. 这个二分图,难不在Hungary算法,而是难在于建图.需要挺高的抽象思维的. 建图: 1 把同一行不被X分开的格子标同一个号码,被X分开的标下一个号码,这样做是为了缩点,不需要把所有的格子都分开标号,而且可以更方便建个更加小的图. 2 同理把同一列的格子标号 3 然后判断相同一个格子的行标号和列标号是有路径的,其他不在同一个格子的都是没有路径的. 4 这样就等于以行标号和列标号作为左右顶点,构建成一个二分图了 然后使用H